<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateFieldsTable extends Migration
{
    public function up(): void
    {
        Schema::create('fields', function (Blueprint $table): void {
            $table->increments('id');
            $table->unsignedInteger('model_id')->nullable();
            $table->string('model_type')->nullable();
            $table->unsignedInteger('section_id')->nullable();
            $table->string('type');
            $table->string('label')->nullable();
            $table->string('name')->nullable();
            $table->schemalessAttributes('data');
            $table->timestamps();

            $table->index(['model_id', 'model_type']);
            $table->index('model_type');
            $table->index('section_id');
            $table->index(['model_type', 'section_id']);
            $table->index('type');
        });
    }
}
